//class MyThread extends Threads...
class Threads extends Thread {
  Complex zNeu,zAlt,C,z0;
  double xmin,ymin;
  double y=0;
  double x=0;
  double radius =0;
  double[] mittelRadius = new double[8];//maximal 16 Ringe
  double[] trapAbstandRadius = new double[8];//zugehörige Breiten der traps
  color farbe;
  PGraphics pg;
  int maxiterations;
  int tN;
  int maxN =0; //Kontrolle
  double massFuerUnendlich;
  double wh;
  double nZwischen;
  protected boolean running = false;
  int zaehlen;
  boolean julia;
  double aQMax =0;
  double x0 ;
  double y0 ;
  int farbIndex =0;
  int trapFaktor;
  int ordnungSpreizung = 1000; //bestimmt, wie stark die Farben im Bereich der Ordung variieren.
  double aQ,laenge;
  Complex [] MP;
  double r,R;
  double mR,mI;
  boolean trapped;
  boolean inEinemKreis = false;
  boolean[] imRing = new boolean[8];//bis zu 16 Ringe sind hier möglich
  int [] anzahlTreffer = new int[8];
  int max = 0;//temp Hilfgröße
  int j;
  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public Threads(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, int nummer, double X0, double Y0, boolean Julia) {
    // benötigte Parameter
    tN = nummer; 
    wh = pwh;
    xmin=px0; ymin=py0; 
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
    aQ =0;
    for(int i=0; i<8; i++){
      imRing[i] = false;   
    }
    for(int i=0; i<8; i++){
      anzahlTreffer[i] = 0;   
    }
    for(int i=0; i<8; i++){
      mittelRadius[i] = 0.1 + i*0.05;   
    }  
    for(int i=0; i<8;i++){
      trapAbstandRadius[i] =0.002+ i*0.0002;
     
    }
    C = new Complex(X0,Y0);
    trapFaktor = 400000; 
     r=0.05; //Radius der 8 Kreise
    R=r/Math.sin(Math.PI/8);//Abstand der 8 Mittelpunkte zum Ursprung
    MP = new Complex [8];
    for (int i =0; i<8; i++){//Kreismittelpunkte
      mR = R*Math.cos(i*Math.PI/4);
      mI = R*Math.sin(i*Math.PI/4);
      MP[i] = new Complex(mR,mI);
    }
    pg = createGraphics(width,height/anzahlThreads);
    julia = Julia;
   
  }
  
  public int gibNummer(){   
    return tN;   
  }

 //////////////////////////////////////////////////////////////
  
  public void run() {
    tN =this.gibNummer(); 
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        double ymax = ymin + wh;
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  
          double x = xmin; 
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
            if(julia){ 
            int n = juliaIteration(z0);
            pg.pixels[i+j*pg.width] = colorize(n);
             
           }else{
             int n = mandelbrotIteration(z0);          
            pg.pixels[i+j*pg.width] = colorize(n);
            }         
            x += dx; 
          }
          y += dy;
        }
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
  }
  
/////////////////////////////////////////////////////////////////////
int juliaIteration(Complex Z0) {
 
  // nun wird für eine komplexe Zahl bzw. einen Punkt der Ebene getestet, 
  // wohin er bei der Iteration geht. Je nachdem wird er dann später eingefärbt  
 int n = 0; 
 for(int i=0; i<8; i++){
      imRing[i] = false;   
 }
  
 zAlt = Z0;
 while (n < maxiterations) {
    trapped = false;
    zNeu = (zAlt.multiply(zAlt)).multiply(zAlt);
    zNeu = zNeu.addC(C);
    laenge =zNeu.getLength();
    aQ = ordnungSpreizung*laenge;
    if (laenge > massFuerUnendlich) {
      break;  // Bail
    }
    
    if (R-r<zNeu.getLength() && zNeu.getLength()<R+r && n >0 ){//gefangen in einem der 8 Kreise     
       j=0; 
       double b=0;
       while(j <8){       
         b = MP[j].subtractC(zNeu).getLength();
         if (b < r){
            trapped = true;
            inEinemKreis = true;
            int fWert = (int)(512*b);
            if (fWert > 127) fWert =127;
            if (fWert <0) fWert =0;
            n =2* j*128+fWert; 
            break;
         }      
       j++;
      }
      if(trapped == true)  break;     
    }
    
    x= Math.abs(zNeu.getRealPart());
    y =Math.abs(zNeu.getImaginaryPart());
    radius = Math.sqrt(x*x+y*y);
    for(int i=0; i<8;i++){  
       if (Math.abs(mittelRadius[i]-radius) < trapAbstandRadius[i] && !trapped ){
            nZwischen = trapFaktor/(i+1)*Math.abs(mittelRadius[i]-radius);
            imRing[i] = true;
            trapped = true;  
            n = (int)nZwischen;         
       }
    } 
    if(trapped) break;
    zAlt = zNeu;
    n++;
  }
  return n;
 }
 /////////////////////////////////////////////////////////////////////
int mandelbrotIteration(Complex C) {
  julia =false;
  trapped = false;
  int n = 0;
  zAlt = C;
  
  while (n < maxiterations) {
    zNeu = (zAlt.multiply(zAlt)).multiply(zAlt);
    zNeu = zNeu.addC(C);
    laenge =zNeu.getLength();
    aQ = 1000*laenge; 
    if (laenge > massFuerUnendlich) {
      break;  // Bail
    }
    zAlt = zNeu;
    n++;
  }  
  return n;
 }

////////////////////////////////////////////////////////////////////
color colorize(int n) {
  // jedes Pixel wird entsprechend der Anzahl Iterationen eingefärbt
  int treffer = -1; int k =-1;
  while(treffer == -1 && k <7){ //bei 16 Farben  k<15
    k++;
    if(imRing[k]) treffer = k;
  }
  if (n == maxiterations){//Ordnung
    farbIndex = (int) aQ % 1024;
    farbe  = farben.farben1024B[farbIndex];  
  }
  else if(!trapped){  //Chaos ohne Tap
    //farbIndex = 4*n % 8192;
    //farbe = farben.farben8192Bonbon[farbIndex];
    farbe = color(0);
  }
  else if(inEinemKreis){
       farbIndex = n % 1152;
       farbe = farben.farben8Kreise1152[farbIndex]; 
       inEinemKreis = false;
    }
  else if(treffer != -1){//trapped  in einem Ring
   // anzahlTreffer[k] = anzahlTreffer[k]+1;  
    farbIndex =n % 1024;
    farbe = farben.farbenTrapZufall1024[2*k][farbIndex];  
    
  }
 
 else farbe = color(0);//kommt in der Regel nicht vor...
 return farbe;
 }
}
